/*uncomment the comments in processACK() processBye() processInvite()->TheAT
  for video test
 */

import javax.sip.*;
import javax.sip.address.*;
import javax.sip.header.*;
import javax.sip.message.*;
import java.util.*;
import javax.sdp.*;

public class ToRegister implements SipListener {

	// =========modify to do file transmission
	// public AVTransmit2 ToRTP; //class declare
	public String SelectFileName;
	public String TheUAIP;
	public AVTransmit2[] TheAT = new AVTransmit2[100]; // AVT declare
	public boolean[] TheIndexUsed = new boolean[100];

	public Hashtable Table = new Hashtable();
	public String RequestCallID;

	public int RequestPort;
	public String UARTPport1 = "";
	public String UARTPport2 = "";

	int NowIndex = 0;
	int GetIndex = 233;
	// ======================================

	private static SipProvider sipProvider;
	private static AddressFactory addressFactory;
	private static MessageFactory messageFactory;
	private static HeaderFactory headerFactory;

	protected ServerTransaction sInviteTid;
	private Response okResponse;
	private Request inviteRequest;

	public int CheckListeningPoint = 0;

	// ===========declare the resource Address here (to Register and open
	// listening point )
	public static String myAddress;
	public static int myPort;
	// ===========declare the registerName(location) here
	public static String Location;

	// ============change the DB server Addr: (register destination)
	private static String peerHostPort = null;

	// private static SipStack sipStack;
	private SipStack sipStack;
	private ContactHeader contactHeader;
	private ListeningPoint udpListeningPoint;
	private ClientTransaction cInviteTid;
	private Dialog dialog;
	protected static final String usageString = "java "
			+ "examples.shootist.Shootist \n"
			+ ">>>> is your class path set to the root?";

	private static void usage() {
		System.out.println(usageString);
		System.exit(0);

	}

	public void processRequest(RequestEvent requestReceivedEvent) {
		Request request = requestReceivedEvent.getRequest();
		ServerTransaction serverTransactionId = requestReceivedEvent
				.getServerTransaction();
		System.out.println("\n\nRequest " + request.getMethod()
				+ " received at " + sipStack.getStackName()
				+ " with server transaction id " + serverTransactionId);
		if (request.getMethod().equals(Request.INVITE)) {
			processInvite(requestReceivedEvent, serverTransactionId);
		} else if (request.getMethod().equals(Request.ACK)) {
			processAck(requestReceivedEvent);
		} else if (request.getMethod().equals(Request.BYE)) {
			processBye(request, serverTransactionId);
		}

	}

	public void processBye(Request request, ServerTransaction st) {
		/*
		 * 這邊看看以後要不要改一下，因為我看過API有定義，這邊應該的ARGUMENT應該是 public void
		 * processBye(RequestEvent requestEvevt, ServerTransaction st)
		 */

		System.out.print("\n===========Resourse got an bye=======\n");
		try {
			if (st == null) {
				System.out.println("Null TID.");
				return;
			}
			System.out.println(request);
			System.out.print("\n=======================================\n");
			RequestCallID = request.getHeader("Call-ID").toString();

			GetIndex = Integer.parseInt(Table.get(RequestCallID).toString());

			TheAT[GetIndex].stop();

			TheIndexUsed[GetIndex] = false;
			Table.remove(RequestCallID);

			System.out.println("Close the transmit at " + GetIndex);

			Response response = messageFactory.createResponse(Response.OK,
					request);

			dialog = st.getDialog();
			st.sendResponse(response);

		} catch (Exception ex) {
			ex.printStackTrace();
			System.exit(0);
		}
	}

	public void processAck(RequestEvent requestEvent) {
		System.out.println("\nGot ACK.");

		// ===============Start to RTP transmitsion==================
		System.out
				.println("===============Start to RTP transmitsion==================");

		System.out.println("Start a transmit");
		System.out.println("file name:" + SelectFileName);
		TheUAIP = TheUAIP.replaceAll("\r\n", "");
		System.out.println("UAIP:" + TheUAIP);
		System.out.println("UARTPport1:" + UARTPport1);
		System.out.println("UARTPport2:" + UARTPport2);
		System.out.println("NowIndex=" + NowIndex);

		String RscRTPport = Integer.toString(11000 + NowIndex * 4);

		// open rtp session

		TheAT[NowIndex] = AVTransmit2.StartTransmit(SelectFileName, TheUAIP,
				UARTPport1, UARTPport2, RscRTPport);

		String result = TheAT[NowIndex].start();

		if (result != null) {
			System.err.println("Error : " + result);
			// System.exit(0);
		}

	}

	public void processResponse(ResponseEvent responseReceivedEvent) {
		System.out.println("Got a response");
		Response response = (Response) responseReceivedEvent.getResponse();
		ClientTransaction tid = responseReceivedEvent.getClientTransaction();
		CSeqHeader cseq = (CSeqHeader) response.getHeader(CSeqHeader.NAME);

		System.out.println("Response received : Status Code = "
				+ response.getStatusCode() + " " + cseq);
		System.out.println(response.toString());

		if (tid == null) {
			System.out.println("Stray response -- dropping ");
			return;
		}
		System.out.println("transaction state is " + tid.getState());
		System.out.println("Dialog = " + tid.getDialog());
		System.out.println("Dialog State is " + tid.getDialog().getState());

		try {
			if (response.getStatusCode() == Response.OK) {
				if (cseq.getMethod().equals(Request.REGISTER)) {
					Request ackRequest = dialog.createRequest(Request.ACK);
					System.out
							.println("get OK from server->register sucessfully\n");
					System.out.println("Sending ACK");
					dialog.sendAck(ackRequest);
				} else if (cseq.getMethod().equals(Request.CANCEL)) {
					if (dialog.getState() == DialogState.CONFIRMED) {
						// oops cancel went in too late. Need to hang up the
						// dialog.
						System.out
								.println("Sending BYE -- cancel went in too late !!");
						Request byeRequest = dialog.createRequest(Request.BYE);
						ClientTransaction ct = sipProvider
								.getNewClientTransaction(byeRequest);
						dialog.sendRequest(ct);

					}

				}
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			System.exit(0);
		}

	}

	public void processInvite(RequestEvent requestEvent,
			ServerTransaction serverTransaction) {
		SipProvider sipProvider = (SipProvider) requestEvent.getSource();
		Request request = requestEvent.getRequest();

		String sdpIP;

		try {
			System.out
					.print("\n===========Resourse got an Invite sending Trying=======\n");
			System.out.print(request.toString());
			System.out
					.print("\n========================================================\n");

			RequestCallID = request.getHeader("Call-ID").toString();

			if (Table.containsKey(RequestCallID) == false) {
				System.out.println("The CallID does not exist");
				// ===get a new index to the new request for video and save to
				// table
				NowIndex = AvailableIndex();
				if (NowIndex >= 0) {
					TheIndexUsed[NowIndex] = true;
				}
				Table.put(RequestCallID, NowIndex);
				System.out.println("add Table:" + RequestCallID + "==>"
						+ Table.get(RequestCallID));

				// ===========parsing request to get request file
				// Name(SelectFileName) and UA's IP(TheUAIP) and UARtpPort
				String Fullrequest = request.toString();
				String UArequest = request.toString();
				String UAIPrequest = Fullrequest.substring(Fullrequest
						.indexOf("Contact:"), Fullrequest.indexOf("Video:"));
				UAIPrequest = UAIPrequest.replaceFirst("Contact:", "");
				UAIPrequest = UAIPrequest.replaceFirst(".*@", "");

				// UAIP
				TheUAIP = UAIPrequest.replaceAll(":.*", "");
				// fileName
				SelectFileName = Fullrequest.substring(Fullrequest
						.indexOf("Video:"), Fullrequest.indexOf("###"));
				SelectFileName = SelectFileName.replaceAll("Video: ", "");
				// UA rtp port (set 1234)
				UARTPport1 = Fullrequest.substring(Fullrequest
						.indexOf("m=video"), Fullrequest.indexOf(" RTP/AVP"));
				UARTPport1 = UARTPport1.replaceFirst("m=video ", "");

				Fullrequest = Fullrequest.replaceFirst("RTP/AVP", "");
				UARTPport2 = Fullrequest.substring(Fullrequest
						.indexOf("m=audio"), Fullrequest.indexOf(" RTP/AVP"));
				UARTPport2 = UARTPport2.replaceFirst("m=audio ", "");

				sdpIP = TheUAIP;
				// =====end parsing==================

			} else {// it is a reinvite to change location
				System.out.println("The CallID Exist(reinvite)!!");
				// look up the table
				GetIndex = Integer
						.parseInt(Table.get(RequestCallID).toString());
				System.out.println("change the transmit at index=" + GetIndex);

				int begin, end;
				String FullRequest = request.toString();
				begin = FullRequest.indexOf("Contact:");
				end = FullRequest.indexOf("Content-Length");
				String NewIP = FullRequest.substring(begin, end);
				begin = NewIP.indexOf("<");
				end = NewIP.indexOf(">");
				NewIP = NewIP.substring(begin, end);
				NewIP = NewIP.replaceAll(".*@", "");
				NewIP = NewIP.replaceAll(":.*", "");

				System.out.println("new location of UA: " + NewIP + "!!!!");

				// UA rtp port (set 1234)
				UARTPport1 = FullRequest.substring(FullRequest
						.indexOf("m=video"), FullRequest.indexOf(" RTP/AVP"));
				UARTPport1 = UARTPport1.replaceFirst("m=video ", "");
				// ====================process the rtp session, change
				// destination to a new ip
				TheAT[GetIndex]
						.changeDestination(NewIP, UARTPport1, UARTPport2);

				sdpIP = NewIP;
			}

			// send response
			Response response = messageFactory.createResponse(Response.TRYING,
					request);
			ServerTransaction st = requestEvent.getServerTransaction();

			if (st == null) {
				st = sipProvider.getNewServerTransaction(request);
			}
			dialog = st.getDialog();

			st.sendResponse(response);

			this.okResponse = messageFactory.createResponse(Response.OK,
					request);
			Address address = addressFactory.createAddress("Shootme <sip:"
					+ myAddress + ":" + myPort + ">");
			ContactHeader contactHeader = headerFactory
					.createContactHeader(address);
			response.addHeader(contactHeader);
			ToHeader toHeader = (ToHeader) okResponse.getHeader(ToHeader.NAME);
			toHeader.setTag("4321"); // Application is supposed to set.
			okResponse.addHeader(contactHeader);

			// ====================create sdp======================
			// Create ContentTypeHeader
			ContentTypeHeader contentTypeHeader = headerFactory
					.createContentTypeHeader("application", "sdp");

			SdpFactory sdpFactory = SdpFactory.getInstance();
			String sdpData = null;

			try { // ======use SessionDescription to package all parameter
				SessionDescription sd = sdpFactory.createSessionDescription();

				// v= Protocol version.
				Version version = sdpFactory.createVersion(0);

				// o=. Owner/creator and session identifier.
				// createOrigin(String userName, String address)
				Origin origin = sdpFactory.createOrigin("UA", sdpIP);

				// c=. Connection information.
				// createConnection(String netType,String addrType, String addr)
				// Returns a Connection object with the specified properties and
				// a network and address type of "IN" and "IP4" respectively.
				Connection connection = sdpFactory.createConnection("IN",
						"IP4", sdpIP);

				// s=. Session name.
				// createSessionName(String name)
				// Returns SessionName object with the specified name.
				SessionName sessionname = sdpFactory
						.createSessionName("Session from UA to Rsc");

				sd.setVersion(version);
				sd.setOrigin(origin);
				sd.setConnection(connection);
				sd.setSessionName(sessionname);

				// createMediaDescription(String media,int port,int
				// numPorts,String transport,String[] formats)
				String[] format = new String[1];
				format[0] = Integer.toString(SdpConstants.PCMU);

				Vector mds = new Vector();
				MediaDescription md1 = sdpFactory.createMediaDescription(
						"video", Integer.parseInt(UARTPport1), 1, "RTP/AVP",
						format);
				MediaDescription md2 = sdpFactory.createMediaDescription(
						"audio", Integer.parseInt(UARTPport2), 1, "RTP/AVP",
						format);

				Vector attrs1 = new Vector();
				Vector attrs2 = new Vector();

				Attribute attr1 = sdpFactory.createAttribute("rtcp", Integer
						.toString(Integer.parseInt(UARTPport1) + 1)); // rtp
																		// port+1
				Attribute attr2 = sdpFactory.createAttribute("rtpmap",
						"0 pcmu/8000");
				Attribute attr3 = sdpFactory.createAttribute("recvonly", null);
				attrs1.addElement(attr1);
				attrs1.addElement(attr2);
				attrs1.addElement(attr3);

				attr1 = sdpFactory.createAttribute("rtcp", Integer
						.toString(Integer.parseInt(UARTPport2) + 1)); // rtp
																		// port+1

				attrs2.addElement(attr1);
				attrs2.addElement(attr2);
				attrs2.addElement(attr3);

				md1.setAttributes(attrs1);
				md2.setAttributes(attrs2);
				mds.addElement(md1);
				mds.addElement(md2);
				sd.setMediaDescriptions(mds);
				sdpData = sd.toString();

			} catch (SdpException ex) {
				System.err.print(ex.toString());
			}

			byte[] contents = sdpData.getBytes();
			okResponse.setContent(contents, contentTypeHeader);

			this.sInviteTid = st;
			// Defer sending the OK to simulate the phone ringing.
			// Answered in 1 second ( this guy is fast at taking calls)
			this.inviteRequest = request;

		} catch (Exception ex) {
			ex.printStackTrace();
			System.exit(0);
		}

		try {
			if (sInviteTid.getState() != TransactionState.COMPLETED) {
				System.out.println("shootme: Dialog state before 200: "
						+ sInviteTid.getDialog().getState());
				sInviteTid.sendResponse(okResponse);
				System.out.println("shootme: Dialog state after 200: "
						+ sInviteTid.getDialog().getState());
			}
		} catch (SipException ex) {
			ex.printStackTrace();
		} catch (InvalidArgumentException ex) {
			ex.printStackTrace();
		}
	}

	public void processTimeout(javax.sip.TimeoutEvent timeoutEvent) {
		System.out.println("Transaction Time out");
	}

	public void register(String LocationName, String IP, int port,
			String FileList, String IPPort) {
		peerHostPort = IPPort;
		SipFactory sipFactory = null;
		sipStack = null;
		sipFactory = SipFactory.getInstance();
		sipFactory.setPathName("gov.nist");
		Properties properties = new Properties();
		// If you want to try TCP transport change the following to
		String transport = "udp";
		// ======= the Location and myAddress myPort are gotten from ResourceGUI
		Location = LocationName;
		myAddress = IP;
		myPort = port;

//		properties.setProperty("javax.sip.OUTBOUND_PROXY", peerHostPort + "/"
//				+ transport);
		// If you want to use UDP then uncomment this.
		properties.setProperty("javax.sip.STACK_NAME", "shootist");
		properties
				.setProperty("gov.nist.javax.sip.MAX_MESSAGE_SIZE", "1048576");
		properties.setProperty("gov.nist.javax.sip.DEBUG_LOG",
				"shootistdebug.txt");
		properties.setProperty("gov.nist.javax.sip.SERVER_LOG",
				"shootistlog.txt");

		// Drop the client connection after we are done with the transaction.
		properties.setProperty("gov.nist.javax.sip.CACHE_CLIENT_CONNECTIONS",
				"false");
		// Set to 0 in your production code for max speed.
		// You need 16 for logging traces. 32 for debug + traces.
		// Your code will limp at 32 but it is best for debugging.
		properties.setProperty("gov.nist.javax.sip.TRACE_LEVEL", "16");

		try {
			sipStack = sipFactory.createSipStack(properties);
			System.out.println("createSipStack " + sipStack);
		} catch (PeerUnavailableException e) {
			e.printStackTrace();
			System.err.println(e.getMessage());
			System.exit(0);
		}

		try {
			headerFactory = sipFactory.createHeaderFactory();
			addressFactory = sipFactory.createAddressFactory();
			messageFactory = sipFactory.createMessageFactory();
			// =======create ListeningPoint in OpenPort()
			if (CheckListeningPoint == 0) {
				OpenPort();
			}


		} catch (Exception ex) {
			System.out.println(ex.getMessage());
			ex.printStackTrace();
			System.out.println("error 3\n");
			usage();
		}

	}

	public void OpenPort() {

		// create ListeningPoint
		try {
			// change myAddress to theIP and port
			udpListeningPoint = sipStack.createListeningPoint(myAddress,
					myPort, "udp");
			sipProvider = sipStack.createSipProvider(udpListeningPoint);
			ToRegister listener = this;
			sipProvider.addSipListener(listener);
			System.out.print("~~~~~OPEN~~~~~~~~~~\n");
			CheckListeningPoint = 1;

		} catch (Exception ex) {
			System.out.println(ex.getMessage());
			ex.printStackTrace();
			System.out.println("error 3\n");
			usage();
		}
	}

	public static void main(String args[]) {

	}

	public void processIOException(IOExceptionEvent exceptionEvent) {
		System.out.println("IOException happened for "
				+ exceptionEvent.getHost() + " port = "
				+ exceptionEvent.getPort());

	}

	public void processTransactionTerminated(
			TransactionTerminatedEvent transactionTerminatedEvent) {
		System.out.println("Transaction terminated event recieved");
	}

	public void processDialogTerminated(
			DialogTerminatedEvent dialogTerminatedEvent) {
		System.out.println("dialogTerminatedEvent");

	}

	public int AvailableIndex() {
		for (int i = 0; i < 100; i++) {
			if (TheIndexUsed[i] == false)
				return i;

		}
		return -1;
	}
}
