import javax.sip.address.AddressFactory;
import javax.sip.header.CallIdHeader;
import javax.sip.header.ContentTypeHeader;
import javax.sip.header.HeaderFactory;
import javax.sip.header.MaxForwardsHeader;
import javax.sip.message.MessageFactory;

public class PCSParameter {
	AddressFactory addressFactory;
	MessageFactory messageFactory;
	HeaderFactory headerFactory;

	String fromUserName;
	String fromSipAddress;
	String fromDisplayName;
	String fromTag;
	String toUserName;
	String toSipAddress;
	String toDisplayName;
	String toTag = null;
	String requestHostPort;

	// Via header
	String UAIPaddr;
	int UASIPPort;
	String Transport_Portocol;

	// Content Header
	ContentTypeHeader contentHeader;

	// Call-ID Header
	CallIdHeader callIdHeader;

	// MaxForwardsHeader maxForwards
	MaxForwardsHeader maxForwardHeader;

	// ContactHeader
	String NewIP;
	int ContactPort;

	// SDP media information
	int audioRTPPort;
	int videoRTPPort;
	int audioRTCPPort;
	int videoRTCPPort;
	
	public PCSParameter(ContentTypeHeader content, CallIdHeader callid,
			MaxForwardsHeader max) {
		this.contentHeader = content;
		this.callIdHeader = callid;
		this.maxForwardHeader = max;
	}
}
